hijack/urls.py
from compat import url

from hijack import settings as hijack_settings
from hijack import views

app_name = 'hijack'
urlpatterns = [
    url(
        r'^release-hijack/$',
        views.release_hijack,
        name='release_hijack'
    )
]

if hijack_settings.HIJACK_DISPLAY_WARNING:
    urlpatterns.append(url(
        r'^disable-hijack-warning/$',
        views.disable_hijack_warning,
        name='disable_hijack_warning'
    ))

hijacking_user_attributes = hijack_settings.HIJACK_URL_ALLOWED_ATTRIBUTES
if 'email' in hijacking_user_attributes:
    urlpatterns.append(url(
        r'^email/(?P<email>[^@\s]+@[^@\s]+\.[^@\s]+)/$',
        views.login_with_email,
        name='login_with_email'
    ))
if 'username' in hijacking_user_attributes:
    urlpatterns.append(url(
        r'^username/(?P<username>.*)/$',
        views.login_with_username,
        name='login_with_username'
    ))
if 'user_id' in hijacking_user_attributes:
    urlpatterns.append(url(
        r'^(?P<user_id>[\w-]+)/$',
        views.login_with_id,
        name='login_with_id'
    ))

hijack/models.py
"""Just an empty models file to let the testrunner recognize this as app."""

hijack/views.py
# -*- encoding: utf-8 -*-
from django.contrib.auth.decorators import login_required
from django.http import HttpResponseBadRequest
from django.shortcuts import get_object_or_404

from hijack.decorators import hijack_require_http_methods, hijack_decorator
from hijack.helpers import login_user, redirect_to_next
from hijack.helpers import release_hijack as release_hijack_fx

from compat import get_user_model


@hijack_decorator
@hijack_require_http_methods
def login_with_id(request, user_id):
    # input(user_id) is unicode
    try:
        user_id = int(user_id)
    except ValueError:
        return HttpResponseBadRequest('user_id must be an integer value.')
    user = get_object_or_404(get_user_model(), pk=user_id)
    return login_user(request, user)


@hijack_decorator
@hijack_require_http_methods
def login_with_email(request, email):
    user = get_object_or_404(get_user_model(), email=email)
    return login_user(request, user)


@hijack_decorator
@hijack_require_http_methods
def login_with_username(request, username):
    user = get_object_or_404(get_user_model(), username=username)
    return login_user(request, user)


@login_required
@hijack_require_http_methods
def release_hijack(request):
    return release_hijack_fx(request)


@login_required
@hijack_require_http_methods
def disable_hijack_warning(request):
    request.session['display_hijack_warning'] = False
    return redirect_to_next(request, default_url='/')

hijack/templates/hijack/notifications.html
{% load url from compat %}
{% load i18n %}

<div id="hijacked-warning-wrapper">
<div id="hijacked-warning" class="hijacked-warning hijacked-warning-default">
    <span style="padding-top: 4px; float: left;"><b>{% blocktrans with user=request.user%}You are currently working on behalf of {{ user }}.{% endblocktrans %}</b></span>
    <div class="hijacked-warning-controls hijacked-warning-controls-pull-right">
        <form action="{% url 'hijack:release_hijack' %}" method="POST">
            {% csrf_token %}
            <button class="django-hijack-button-default">{% blocktrans with user=request.user %}release {{ user }}{% endblocktrans %}</button>
        </form>
        <form action="{% url 'hijack:disable_hijack_warning' %}?next={{ request.path }}" method="POST">
            {% csrf_token %}
            <button type="submit" class="django-hijack-button-default">{% trans "hide" %}</button>
        </form>
    </div>
</div>
</div>

hijack/templates/hijack/notifications_bootstrap.html
{% load url from compat %}
{% load i18n %}

<div id="hijacked-warning" class="alert hijacked-warning hijacked-warning-bootstrap" role="alert">
    {% blocktrans with user=request.user%}You are currently working on behalf of {{ user }}.{% endblocktrans %}
    <div class="hijacked-warning-controls">
        <form action="{% url 'hijack:release_hijack' %}" method="POST">
            {% csrf_token %}
            <button type="submit" class="btn btn-default btn-sm django-hijack-button-bootstrap">{% blocktrans with user=request.user %}release {{ user }}{% endblocktrans %}</button>
        </form>
        <form action="{% url 'hijack:disable_hijack_warning' %}?next={{ request.path }}" method="POST">
            {% csrf_token %}
            <button type="submit" class="close" data-dismiss="alert">×</button>
        </form>
    </div>
</div>